<%@ page contentType="text/html; charset=UTF-8" pageEncoding="UTF-8" %>

<%@ page import="java.util.LinkedHashMap"%>
<%@ page import="java.util.Map"%>

<%@ page import="jp.co.intra_mart.cookbook.im_cookbook_113639.oauth.client.service.processor.impl.GoogleConstants"%>

<%@ page import="jp.co.intra_mart.foundation.context.Contexts"%>
<%@ page import="jp.co.intra_mart.foundation.context.model.AccountContext"%>
<%@ page import="jp.co.intra_mart.foundation.oauth.client.model.AccessTokenInfo"%>
<%@ page import="jp.co.intra_mart.foundation.oauth.client.service.OAuthClientService"%>
<%@ page import="jp.co.intra_mart.foundation.oauth.client.service.OAuthClientServiceFactory"%>

<%@ page import="org.apache.commons.httpclient.Header"%>
<%@ page import="org.apache.commons.httpclient.HttpClient"%>
<%@ page import="org.apache.commons.httpclient.methods.GetMethod"%>

<%
final String uri = "https://www.googleapis.com/drive/v3/files";

final String userCd = Contexts.get(AccountContext.class).getUserCd();
final String providerId = "im_cookbook_113639_oauth_client_google";

final OAuthClientService oAuthClient = OAuthClientServiceFactory.getInstance().getOAuthClientService(GoogleConstants.PROVIDER_TYPE);
final AccessTokenInfo token = oAuthClient.getAccessToken(userCd, providerId);

int status;
Map<String, String> responseHeaders;
String responseBodyAsString;

final GetMethod httpRequest = new GetMethod(uri);
try{
    httpRequest.addRequestHeader("Authorization", token.getTokenType() + " " + token.getAccessToken()); // <-- Set AccessToken
    httpRequest.addRequestHeader("Content-Type", "application/json; charset=UTF-8");
    httpRequest.addRequestHeader("Accept", "application/json");
    
    status = new HttpClient().executeMethod(httpRequest);
    
    responseHeaders = new LinkedHashMap<>();
    for (final Header header : httpRequest.getResponseHeaders()) {
        responseHeaders.put(header.getName(), header.getValue());
    }
    
    responseBodyAsString = httpRequest.getResponseBodyAsString();
} finally {
    httpRequest.releaseConnection();
}

%>

<table border="1">
	<tr>
		<th>status</th>
		<td><%=status%></td>
	</tr>
	<tr>
		<th>responseHeaders</th>
		<td><pre><%=responseHeaders%></pre></td>
	</tr>
	<tr>
		<th>responseBodyAsString</th>
		<td><pre><%=responseBodyAsString%></pre></td>
	</tr>
</table>